
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>ORM中去除反射，添加Expression / 憋错料</title>

    <meta name="description" content="ORM中去除反射，添加Expression 之前接触了别人的ORM框架,感觉牛掰到不行,然后试着自己来写自己的ORM. 最初从园子里找到其他人写的反射的例子: 1 List&lt;PropertyInfo&gt; pis = typeof(T).GetProperties().ToList&lt;PropertyInfo&gt;() 2 while (dr.Read()) 3 { 4 T model = Activator.CreateInstance&lt;T&gt;(); 5 6 foreach (PropertyInfo prope ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">ORM中去除反射，添加Expression</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>之前接触了别人的ORM框架，感觉牛掰到不行，然后试着自己来写自己的ORM。</p>
<p>最初从园子里找到其他人写的反射的例子：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<pre> 1     List&lt;PropertyInfo&gt; pis = typeof(T).GetProperties().ToList&lt;PropertyInfo&gt;()
 2     while (dr.Read())
 3      {
 4        T model = Activator.CreateInstance&lt;T&gt;();
 5
 6         foreach (PropertyInfo propertyInfo in pis)
 7         {
 8          propertyInfo.SetValue(model,dr[propertyInfo.Name], null);
 9          }
10            list.Add(model);
11        }</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<p>基本满足需求，但是性能和Dapper相比，完全被打趴下了啊。<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 偶然发现了Expression，好吧，不试怎么知道好用？</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<pre> 1         public Action&lt;T, IDataRecord&gt; SetValueToEntity&lt;T&gt;(int index, string ProPertyName, Type FieldType)
 2         {
 3             Type datareader = typeof(IDataRecord);
 4             //获取调用方法
 5             System.Reflection.MethodInfo Method = GetMethod(FieldType, datareader);
 6             ParameterExpression e = Expression.Parameter(typeof(T), "e");
 7             ParameterExpression r = Expression.Parameter(datareader, "r");
 8             //常数表达式
 9             ConstantExpression i = Expression.Constant(index);
10             MemberExpression ep = Expression.PropertyOrField(e, ProPertyName);
11             MethodCallExpression call = Expression.Call(r, Method, i);
12             BinaryExpression assignExpression = Expression.Assign(ep, call);
13             Expression&lt;Action&lt;T, IDataRecord&gt;&gt; resultEx = Expression.Lambda&lt;Action&lt;T, IDataRecord&gt;&gt;(assignExpression, e, r);
14             Action&lt;T, IDataRecord&gt; result = resultEx.Compile();
15             return result;
16         }
17
18         public static MethodInfo GetMethod(Type FieldType, Type datareader)
19         {
20             switch (FieldType.FullName)
21             {
22                 case "System.Int16":
23                     return datareader.GetMethod("GetInt16");
24
25                 case "System.Int32":
26                     return datareader.GetMethod("GetInt32");
27
28                 case "System.Int64":
29                     return datareader.GetMethod("GetInt64");
30
31                 case "Double":
32                     return datareader.GetMethod("GetDouble");
33
34                 case "System.String":
35                     return datareader.GetMethod("GetString");
36
37                 case "Boolean":
38                     return datareader.GetMethod("GetBoolean");
39
40                 case "Char":
41                     return datareader.GetMethod("GetChar");
42
43                 case "System.Guid":
44                     return datareader.GetMethod("GetGuid");
45
46                 case "Single":
47                     return datareader.GetMethod("GetFloat");
48
49                 case "Decimal":
50                     return datareader.GetMethod("GetDecimal");
51
52                 case "System.DateTime":
53                     return datareader.GetMethod("GetDateTime");
54                 case "System.":
55                     return datareader.GetMethod("GetDateTime");
56             }
57             return null;
58         }
59
60  List&lt;Action&lt;T, IDataReader&gt;&gt; actionDics = new List&lt;Action&lt;T, IDataReader&gt;&gt;();
61             //数据实体类型
62             var perDic = typeof(T).GetProperties().ToDictionary(p =&gt; p.Name);
63             //生成表头
64             for (int i = 0; i &lt; dr.FieldCount; i++)
65             {
66                 //获取列名
67                 string colName = dr.GetName(i);
68                 Type DataType = dr.GetFieldType(i);
69                 if (perDic.ContainsKey(colName))
70                 {
71                     actionDics.Add(SetValueToEntity&lt;T&gt;(i, colName, DataType));
72                 }
73             }
74             while (dr.Read())
75             {
76                 T objT = Activator.CreateInstance&lt;T&gt;();
77                 //填充属性值
78                 actionDics.ForEach(p =&gt; p.Invoke(objT, dr));
79                 list.Add(objT);
80             }</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg" /></p>
<p>结果还是很可人滴，和Dapper不相上下。</p>
<p>下篇希望可以实现增、删、改。希望园友提供下建议。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-17 03:04:06 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>ORM中去除反射，添加Expression的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/j35gD1M.html" rel="bookmark">C&num;基础系列：实现自己的ORM（反射以及Attribute在ORM中的应用）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				反射以及Attribute在ORM中的应用 一. 反射什么是反射?简单点吧,反射就是在运行时动态获取对象信息的方法,比如运行时知道对象有哪些属性,方法,委托等等等等.反射有什么用呢?反射不但让你在运行是获取对象的信息,还提供运行时动态调用对象方法以及动态设置.获取属性等的能力.反射在ORM中有什么用呢?我这里所讨论的ORM实现是通过自定义Attribute的方式进行映射规则的描述的.但是我们并不知道具体哪个对象需要对应哪个表,并且这些对象是独立于我们的ORM框架的,所以我们只能通过自定义Attr			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mg8nBp0.html" rel="bookmark">反射以及Attribute在ORM中的应用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				GPS平台.网站建设.软件开发.系统运维,找森大网络科技!http://cnsendnet.taobao.com来自森大科技官方博客http://www.cnsendblog.com/index.php/?p=488 反射以及Attribute在ORM中的应用一. 反射什么是反射?简单点吧,反射就是在运行时动态获取对象信息的方法,比如运行时知道对象有哪些属性,方法,委托等等等等.反射有什么用呢?反射不但让你在运行是获取对象的信息,还提供运行时动态调用对象方法以及动态设置.获取属性等的能力.反射在			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0endWa3.html" rel="bookmark">ckeditor编辑器中去除p标签</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ckeditor中默认添加p标签.去掉&lt;p&gt;标签的方法在ckeditor文件下config.js中加: config.shiftEnterMode = CKEDITOR.ENTER_P; 如果你想在ckeditor编辑的时候把回车换成&lt;br/&gt;标签,加: config.enterMode = CKEDITOR.ENTER_BR; 如果你想把编辑器设置为源码模式,加: config.startupMode = 'source'; ckeditor编辑器中去除p标签,布布扣,bubuk			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4JYakV3.html" rel="bookmark">详解C&num;中的反射</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				反射(Reflection) 2008年01月02日 星期三 11:21 两个现实中的例子:1.B超:大家体检的时候大概都做过B超吧,B超可以透过肚皮探测到你内脏的生理情况.这是如何做到的呢?B超是B型超声波,它可以透过肚皮通过向你体内发射B型超声波,当超声波遇到内脏壁的时候就会产生一定的“回音”反射,然后把“回音”进行处理就可以显示出内脏的情况了(我不是医生也不是声学专家,不知说得是否准确^_^).2.地球内部结构:地球的内部结构大体可以分为三层:地壳.地幔和地核.地壳是固体,地核是液体,地幔			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MBYYvv4.html" rel="bookmark">android studio 中去除应用标题栏</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				android studio 中去除应用标题栏 ㈠ ⒈ mainifests中设置: android:theme=&quot;@style/AppTheme&quot;(即默认设置). ⒉ values-&gt;styles.xml中设置: style name=&quot;AppTheme&quot; parent=&quot;Theme.AppCompat.Light.NoActionBar&quot;. ㈡ values-&gt;styles.xml中: 在当先使用的style的parent属性添加			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3rZGLg3.html" rel="bookmark">&lbrack;Django&rsqb;orm中的外键级联删除</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这里的系统环境为django1.6   os为win7 今天有个需求说的是添加一个地区表,然后用外键和几个非常重要的实体表来做关联(地区表作为其他表的外键),写完地区的删除操作的时候,测试了下代码,功能正常.可是眼睛移动到控制台输出的时候傻了 connexesql -&gt;DELETE FROM `mngm_device` WHERE `mngm_device`.`area_id` IN (%s, %s, %s) connexesql -&gt;DELETE FROM `ad_ad` WHERE `ad			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPJE8z3.html" rel="bookmark">【转】详解C&num;中的反射</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原帖链接点这里:详解C#中的反射 反射(Reflection) 2008年01月02日 星期三 11:21 两个现实中的例子: 1.B超:大家体检的时候大概都做过B超吧,B超可以透过肚皮探测到你内脏的生理情况.这是如何做到的呢?B超是B型超声波,它可以透过肚皮通过向你体内发射B型超声波,当超声波遇到内脏壁的时候就会产生一定的“回音”反射,然后把“回音”进行处理就可以显示出内脏的情况了(我不是医生也不是声学专家,不知说得是否准确^_^). 2.地球内部结构:地球的内部结构大体可以分为三层:地壳.地			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MVWRxp0.html" rel="bookmark">关于JAVA中的反射机制的总结</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				JAVA中的反射机制是一种能够大大增强程序扩展性的技术.当一个程序封装完成后(生成exe文件),如果想要对该程序进行功能扩展,不用进行代码的从新修改(也不可能拿到源码),只要修改配置文件(一般是XML)就可以完成. 这样的程序为外部提供了一个接口,只要按照该接口的规则定义一个对象(功能),即可以为应用程序扩展该功能. 可以这样比喻,你买了一块电脑主板(封装好的程序),此时你想要添加一块声卡(要扩展的功能),此时只能够通过一个pci接口(应用程序提供的接口)来进行扩展.声卡的接口必须符合PCI的规			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MEN7aP0.html" rel="bookmark">&period;Net 中的反射&lpar;序章&rpar; - Part&period;1</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				引言 反射是.Net提供给我们的一件强力武器,尽管大多数情况下我们不常用到反射,尽管我们可能也不需要精通它,但对反射的使用作以初步了解在日后的开发中或许会有所帮助. 反射是一个庞大的话题,牵扯到的知识点也很多,包括程序集.自定义特性.泛型等,想要完全掌握它非常不易.本文仅仅对反射做一个概要介绍,关于它更精深的内容,需要在实践中逐渐掌握.本文将分为下面几个部分介绍.Net中的反射: 序章,我将通过一个例子来引出反射,获得对反射的第一印象. 反射初步.Type类.反射普通类型.(修改中,近期发布..			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/E3wOJR3.html" rel="bookmark" class="title">C&num;之枚举类型</a>
					<div>
						参考: http://www.cnblogs.com/an-wl/archive/2011/04/14/2015815.html 惯例先上MSDN: https://msdn.microsoft.co ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35V26X4.html" rel="bookmark" class="title">大道至简七八章读后感</a>
					<div>
						第七章 现实中的软件工程     第八章 是思考还是思想 作为大的软件公司,不能只是关注与软件的开发工具,更应该完善公司的理论体系和实作工具,为了与行业的巨头相抗争,就该把握住自身拥有的一切力量,这甚 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEolPy3.html" rel="bookmark" class="title">虚拟摇杆跟随鼠标</a>
					<div>
						EasyTouch的joystick跟随鼠标 1 using UnityEngine; 2 using System.Collections; 3 4 public class JoystickPos ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lXnOL0.html" rel="bookmark" class="title">Struts2 数据驱动</a>
					<div>
						在servlet中获取页面传递过来的数据的方式是:request.getParameter(&quot;username&quot;);这个代码可以获取到页面的username的数据.在action中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bnn2e0.html" rel="bookmark" class="title">离线地图解决方案（二）：地图基本控制</a>
					<div>
						地图鹰眼,比例尺,地图缩放控件应用,地图放大.缩小.设置中心点,设置瓦片显示层级等.功能没什么好说的,直接上图: 代码: &lt;!DOCTYPE HTML PUBLIC &quot;-//W3C// ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lr5LW4.html" rel="bookmark" class="title">delphi中用Table表组件和Query查询组件配合进行的增删改查</a>
					<div>
						一.打开数据库表进入检索状态 var Table1:TTable; //定义Table1为TTable类型的变量 begin Table1:=TTable.Create(self);//自建表 Tab ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41gqxO0.html" rel="bookmark" class="title">以给定值为基分割链表</a>
					<div>
						给定一个值,将链表小于该值得结点放到左边,大于该值得放到右边 例如: Given 1-&gt;4-&gt;3-&gt;2-&gt;5-&gt;2 and x = 3,return 1-&gt;2-&g ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoY72k3.html" rel="bookmark" class="title">HTML笔记（二） 在HTML中使用CSS</a>
					<div>
						外部CSS: &lt;head&gt; &lt;link rel=&quot;stylesheet&quot; type=&quot;text/css&quot; href=&quot;mystyle ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RGqwp3.html" rel="bookmark" class="title">安卓驱动开发（一）</a>
					<div>
						在安卓中, 安卓是以linux系统为基础的,不同的安卓版本使用不同版本的linux做为内核,不过linux2.6是目前使用最广泛的linux内核版本,而安卓 4以上的使用linux3.0的版本,当两台 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBRXrJM.html" rel="bookmark" class="title">余弦方法计算相似度算法实现</a>
					<div>
						http://blog.csdn.net/cscmaker/article/details/7990600 余弦方法计算相似度算法实现 (1)余弦相似性 通过测量两个向量之间的角的余弦值来度量它们之间 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02Ldv24.html" rel="bookmark" class="title">第6周 搜索与排序</a>
					<div>
						 1º 查找里程 给你这样一张里程表,如何写一个程序,输入两地的地名,能输出期间的里程? #include &lt;stdio.h&gt; #include &lt;string.h&gt; #def ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz16VA4.html" rel="bookmark" class="title">Leetcode题解（4）：L216&sol;Combination Sum III</a>
					<div>
						L216: Combination Sum III Find all possible combinations of k numbers that add up to a number n, giv ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bqGApM.html" rel="bookmark" class="title">&period;net 运用YUI相关的dll压缩js （按照自己的规则&comma;想想都觉得强大和有趣）</a>
					<div>
						写在前面 不管是做前端的还是做后台的,不管是懂javaScript的还是不太懂JavaScript的人,我想都或多或想的知道些许js压缩对于页面性能提升的效应吧. 之前老喜欢用在线压缩工具去压缩js, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGRrpZ4.html" rel="bookmark" class="title">数据库管理原理-简介</a>
					<div>
						1.为什么使用数据库管理系统? 答:为了持续运行大数据的现状,能够长期的储存.维护和管理这些数据.比如银行.学校及政府都需要大数据的运用 2.数据库的基本操作有哪些? a)疏忽查询,b)数据插入,c) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xZJWz4.html" rel="bookmark" class="title">Codevs&lowbar;2102&lowbar;石子归并2&lowbar;&lpar;划分型动态规划&rpar;</a>
					<div>
						描述 http://codevs.cn/problem/2102/ 与Codevs_1048_石子归并_(划分型动态规划)相比,现在是环状的,起点任意. 2102 石子归并 2 时间限制: 10 s  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/471Bm90.html" rel="bookmark" class="title">GUI库中RichEdit控件开发的林林总总</a>
					<div>
						之前开发了RichEdit控件,现在回顾总结一下. Rich text format格式(通常缩写为RTF)是一种专有的文档文件格式,是1987年Microsoft对文件跨平台交换开发发布的规范,详情 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nRGYV0.html" rel="bookmark" class="title">js 判断页面是否加载完成</a>
					<div>
						javascript代码如下: document.onreadystatechange = subSomething; //当页面加载状态改变的时候执行这个方法 function subSomethi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OyvPKM.html" rel="bookmark" class="title">巡撬攀性俨偬装壕悠逗残杉讣奖绦</a>
					<div>
						http://i2.feixin.10086.cn/pages/112483/1352116913 http://i2.feixin.10086.cn/pages/112502/1352116912  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0klbaL3.html" rel="bookmark" class="title">App动态更新技术框架Weex与React Native -- valen</a>
					<div>
						工作原理: 大致基本类同,JS-Native桥和前端渲染框架,只是使用框架技术不一样: Weex 阿里内部早期研发的一个通过 JSON 数据描述 native 渲染的项目WeApp以及Vue.js这款 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bKono3.html" rel="bookmark" class="title">Chromium网页光栅化过程分析</a>
					<div>
						在前面一篇文章中,我们分析了网页CC Layer Tree同步为CC Pending Layer Tree的过程.同步操作完成后,CC Pending Layer Tree中的每一个Layer都会被划 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
